<?php
class ControllerModuleGallimage extends Controller {
	private $error = array();

	public function index() {
		$this->load->language('module/gallimage');

		$this->document->setTitle($this->language->get('heading_title'));

		$this->load->model('extension/module');

		$this->document->addScript('view/javascript/jquery/jscolor/jscolor.js');
		$this->document->addStyle('view/javascript/jquery/jscolor/gallimage.css');

        if (version_compare(VERSION, '2.2.0.0', '>=')) {
		if (($this->request->server['REQUEST_METHOD'] == 'POST') && $this->validate()) {
			if (!isset($this->request->get['module_id'])) {
				$this->model_extension_module->addModule('gallimage', $this->request->post);
			} else {
				$this->model_extension_module->editModule($this->request->get['module_id'], $this->request->post);
			}

			$this->session->data['success'] = $this->language->get('text_success');

			$this->response->redirect($this->url->link('extension/module', 'token=' . $this->session->data['token'], true));
		}
        } else {
        if (($this->request->server['REQUEST_METHOD'] == 'POST') && $this->validate()) {
			if (!isset($this->request->get['module_id'])) {
				$this->model_extension_module->addModule('gallimage', $this->request->post);
			} else {
				$this->model_extension_module->editModule($this->request->get['module_id'], $this->request->post);
			}

			$this->session->data['success'] = $this->language->get('text_success');

			$this->response->redirect($this->url->link('extension/module', 'token=' . $this->session->data['token'], 'SSL'));
		}    
        }

		$data['heading_title'] = $this->language->get('heading_title') . '&nbsp;<span style="font-size:1em; color:#999">v1.2.3</span>';

		$data['text_edit'] = $this->language->get('text_edit');
		$data['text_enabled'] = $this->language->get('text_enabled');
		$data['text_disabled'] = $this->language->get('text_disabled');
        $data['text_yes'] = $this->language->get('text_yes');
		$data['text_no'] = $this->language->get('text_no');
		$data['text_pleaseselect'] = $this->language->get('text_pleaseselect');

		$data['entry_name'] = $this->language->get('entry_name');
		$data['entry_limit'] = $this->language->get('entry_limit');
		$data['entry_gallimage'] = $this->language->get('entry_gallimage');
		$data['entry_style'] = $this->language->get('entry_style');
        $data['entry_resize'] = $this->language->get('entry_resize');
		$data['entry_carousel'] = $this->language->get('entry_carousel');
		$data['entry_carauto'] = $this->language->get('entry_carauto');
		$data['entry_image'] = $this->language->get('entry_image');
		$data['entry_width'] = $this->language->get('entry_width');
		$data['entry_height'] = $this->language->get('entry_height');
		$data['entry_status'] = $this->language->get('entry_status');
		$data['entry_popupstyle'] = $this->language->get('entry_popupstyle');
		$data['entry_popupsize'] = $this->language->get('entry_popupsize');
		$data['entry_namefontsize'] = $this->language->get('entry_namefontsize');
		$data['entry_namepos'] = $this->language->get('entry_namepos');
		$data['entry_imgperrow'] = $this->language->get('entry_imgperrow');
		$data['entry_boxgallcol'] = $this->language->get('entry_boxgallcol');
		$data['entry_namecol'] = $this->language->get('entry_namecol');
		$data['entry_bordergall'] = $this->language->get('entry_bordergall');
		$data['entry_borderthick'] = $this->language->get('entry_borderthick');

		$data['button_save'] = $this->language->get('button_save');
		$data['button_cancel'] = $this->language->get('button_cancel');
		$data['button_module_add'] = $this->language->get('button_module_add');
		$data['button_remove'] = $this->language->get('button_remove');

		if (isset($this->error['warning'])) {
			$data['error_warning'] = $this->error['warning'];
		} else {
			$data['error_warning'] = '';
		}

		if (isset($this->error['name'])) {
			$data['error_name'] = $this->error['name'];
		} else {
			$data['error_name'] = '';
		}

        if (version_compare(VERSION, '2.2.0.0', '>=')) {
		$data['breadcrumbs'] = array();

		$data['breadcrumbs'][] = array(
			'text' => $this->language->get('text_home'),
			'href' => $this->url->link('common/dashboard', 'token=' . $this->session->data['token'], true)
		);

		$data['breadcrumbs'][] = array(
			'text' => $this->language->get('text_module'),
			'href' => $this->url->link('extension/module', 'token=' . $this->session->data['token'], true)
		);

		$data['breadcrumbs'][] = array(
			'text' => $this->language->get('heading_title'),
			'href' => $this->url->link('module/gallimage', 'token=' . $this->session->data['token'], true)
		);

		if (!isset($this->request->get['module_id'])) {
			$data['action'] = $this->url->link('module/gallimage', 'token=' . $this->session->data['token'], true);
		} else {
			$data['action'] = $this->url->link('module/gallimage', 'token=' . $this->session->data['token'] . '&module_id=' . $this->request->get['module_id'], true);
		}

		$data['cancel'] = $this->url->link('extension/module', 'token=' . $this->session->data['token'], true);
        } else {
        $data['breadcrumbs'] = array();

		$data['breadcrumbs'][] = array(
			'text' => $this->language->get('text_home'),
			'href' => $this->url->link('common/dashboard', 'token=' . $this->session->data['token'], 'SSL')
		);

		$data['breadcrumbs'][] = array(
			'text' => $this->language->get('text_module'),
			'href' => $this->url->link('extension/module', 'token=' . $this->session->data['token'], 'SSL')
		);

		$data['breadcrumbs'][] = array(
			'text' => $this->language->get('heading_title'),
			'href' => $this->url->link('module/gallimage', 'token=' . $this->session->data['token'], 'SSL')
		);

		if (!isset($this->request->get['module_id'])) {
			$data['action'] = $this->url->link('module/gallimage', 'token=' . $this->session->data['token'], 'SSL');
		} else {
			$data['action'] = $this->url->link('module/gallimage', 'token=' . $this->session->data['token'] . '&module_id=' . $this->request->get['module_id'], 'SSL');
		}

		$data['cancel'] = $this->url->link('extension/module', 'token=' . $this->session->data['token'], 'SSL');    
        }

		if (isset($this->request->get['module_id']) && ($this->request->server['REQUEST_METHOD'] != 'POST')) {
			$module_info = $this->model_extension_module->getModule($this->request->get['module_id']);
		}

		if (isset($this->request->post['name'])) {
			$data['name'] = $this->request->post['name'];
		} elseif (!empty($module_info)) {
			$data['name'] = $module_info['name'];
		} else {
			$data['name'] = '';
		}

		if (isset($this->request->post['limit'])) {
			$data['limit'] = $this->request->post['limit'];
		} elseif (!empty($module_info)) {
			$data['limit'] = $module_info['limit'];
		} else {
			$data['limit'] = 5;
		}

		if (isset($this->request->post['gallimage_id'])) {
			$data['gallimage_id'] = $this->request->post['gallimage_id'];
		} elseif (!empty($module_info)) {
			$data['gallimage_id'] = $module_info['gallimage_id'];
		} else {
			$data['gallimage_id'] = '';
		}

		if (isset($this->request->post['gallimagestyle'])) {
			$data['gallimagestyle'] = $this->request->post['gallimagestyle'];
		} elseif (!empty($module_info)) {
			$data['gallimagestyle'] = $module_info['gallimagestyle'];
		} else {
			$data['gallimagestyle'] = '';
		}
        
        if (isset($this->request->post['gallimageresize'])) {
			$data['gallimageresize'] = $this->request->post['gallimageresize'];
		} elseif (!empty($module_info)) {
			$data['gallimageresize'] = $module_info['gallimageresize'];
		} else {
			$data['gallimageresize'] = 1;
		}

		if (isset($this->request->post['gallimagecar'])) {
			$data['gallimagecar'] = $this->request->post['gallimagecar'];
		} elseif (!empty($module_info)) {
			$data['gallimagecar'] = $module_info['gallimagecar'];
		} else {
			$data['gallimagecar'] = '';
		}

		if (isset($this->request->post['gallimagecarauto'])) {
			$data['gallimagecarauto'] = $this->request->post['gallimagecarauto'];
		} elseif (!empty($module_info)) {
			$data['gallimagecarauto'] = $module_info['gallimagecarauto'];
		} else {
			$data['gallimagecarauto'] = '';
		}

		if (isset($this->request->post['status'])) {
			$data['status'] = $this->request->post['status'];
		} elseif (!empty($module_info)) {
			$data['status'] = $module_info['status'];
		} else {
			$data['status'] = '';
		}

		if (isset($this->request->post['gallimage_popupstyle'])) {
			$data['gallimage_popupstyle'] = $this->request->post['gallimage_popupstyle'];
		} elseif (!empty($module_info)) {
			$data['gallimage_popupstyle'] = $module_info['gallimage_popupstyle'];
		} else {
			$data['gallimage_popupstyle'] = '';
		}

		if (isset($this->request->post['gallimage_namepos'])) {
			$data['gallimage_namepos'] = $this->request->post['gallimage_namepos'];
		} elseif (!empty($module_info)) {
			$data['gallimage_namepos'] = $module_info['gallimage_namepos'];
		} else {
			$data['gallimage_namepos'] = '';
		}

		if (isset($this->request->post['gallimage_namefontsize'])) {
			$data['gallimage_namefontsize'] = $this->request->post['gallimage_namefontsize'];
		} elseif (!empty($module_info)) {
			$data['gallimage_namefontsize'] = $module_info['gallimage_namefontsize'];
		} else {
			$data['gallimage_namefontsize'] = '15';
		}

		if (isset($this->request->post['imgperrow'])) {
			$data['imgperrow'] = $this->request->post['imgperrow'];
		} elseif (!empty($module_info)) {
			$data['imgperrow'] = $module_info['imgperrow'];
		} else {
			$data['imgperrow'] = '3';
		}

		if (isset($this->request->post['gallimage_boxgallcol'])) {
			$data['gallimage_boxgallcol'] = $this->request->post['gallimage_boxgallcol'];
		} elseif (!empty($module_info)) {
			$data['gallimage_boxgallcol'] = $module_info['gallimage_boxgallcol'];
		} else {
			$data['gallimage_boxgallcol'] = '';
		}

		if (isset($this->request->post['gallimage_namecol'])) {
			$data['gallimage_namecol'] = $this->request->post['gallimage_namecol'];
		} elseif (!empty($module_info)) {
			$data['gallimage_namecol'] = $module_info['gallimage_namecol'];
		} else {
			$data['gallimage_namecol'] = '222222';
		}

		if (isset($this->request->post['gallimage_bordercol'])) {
			$data['gallimage_bordercol'] = $this->request->post['gallimage_bordercol'];
		} elseif (!empty($module_info)) {
			$data['gallimage_bordercol'] = $module_info['gallimage_bordercol'];
		} else {
			$data['gallimage_bordercol'] = 'EEEEEE';
		}

		if (isset($this->request->post['gallimage_borderthick'])) {
			$data['gallimage_borderthick'] = $this->request->post['gallimage_borderthick'];
		} elseif (!empty($module_info)) {
			$data['gallimage_borderthick'] = $module_info['gallimage_borderthick'];
		} else {
			$data['gallimage_borderthick'] = '1';
		}

		$data['header'] = $this->load->controller('common/header');
		$data['column_left'] = $this->load->controller('common/column_left');
		$data['footer'] = $this->load->controller('common/footer');

		$this->load->model('catalog/gallimage');

		$data['gallimages'] = $this->model_catalog_gallimage->getGallimages();

        if (version_compare(VERSION, '2.2.0.0', '>=')) {
		$this->response->setOutput($this->load->view('module/gallimage', $data));
        } else {
        $this->response->setOutput($this->load->view('module/gallimage.tpl', $data));    
        }
	}

	public function install() {
        $this->db->query("CREATE TABLE IF NOT EXISTS `" . DB_PREFIX . "gallimage` (`gallimage_id` int(11) NOT NULL AUTO_INCREMENT, `image` varchar(255) DEFAULT NULL, `sort_order` int(3) NOT NULL DEFAULT '0', `status` tinyint(1) NOT NULL, `gwidth` int(11) DEFAULT NULL, `gheight` int(11) DEFAULT NULL, `pwidth` int(11) DEFAULT NULL, `pheight` int(11) DEFAULT NULL, PRIMARY KEY (`gallimage_id`)) ENGINE=MyISAM DEFAULT CHARSET=utf8 AUTO_INCREMENT=1");
		$this->db->query("CREATE TABLE IF NOT EXISTS `" . DB_PREFIX . "gallimage_description` (`gallimage_id` int(11) NOT NULL, `language_id` int(11) NOT NULL, `name` varchar(255) NOT NULL, `description` text NOT NULL, `meta_title` varchar(255) NOT NULL, `meta_description` varchar(255) NOT NULL, `meta_keyword` varchar(255) NOT NULL, PRIMARY KEY (`gallimage_id`,`language_id`), KEY `name` (`name`)) ENGINE=MyISAM DEFAULT CHARSET=utf8");
		$this->db->query("CREATE TABLE IF NOT EXISTS `" . DB_PREFIX . "gallimage_to_store` (`gallimage_id` int(11) NOT NULL, `store_id` int(11) NOT NULL, PRIMARY KEY (`gallimage_id`,`store_id`)) ENGINE=MyISAM DEFAULT CHARSET=utf8");
		$this->db->query("CREATE TABLE IF NOT EXISTS `" . DB_PREFIX . "gallimage_image` (`gallimage_image_id` int(11) NOT NULL AUTO_INCREMENT, `gallimage_id` int(11) NOT NULL, `link` varchar(255) NOT NULL, `image` varchar(255) NOT NULL, `sort_order` int(3) NOT NULL DEFAULT '0', PRIMARY KEY (`gallimage_image_id`) ) ENGINE=MyISAM  DEFAULT CHARSET=utf8 AUTO_INCREMENT=7");
		$this->db->query("CREATE TABLE IF NOT EXISTS `" . DB_PREFIX . "gallimage_image_description` (`gallimage_image_id` int(11) NOT NULL, `language_id` int(11) NOT NULL, `gallimage_id` int(11) NOT NULL, `title` varchar(128) NOT NULL, PRIMARY KEY (`gallimage_image_id`,`language_id`) ) ENGINE=MyISAM DEFAULT CHARSET=utf8");
    }

	public function uninstall() {
		$this->db->query("DROP TABLE IF EXISTS " . DB_PREFIX . "gallimage");
		$this->db->query("DROP TABLE IF EXISTS " . DB_PREFIX . "gallimage_description");
		$this->db->query("DROP TABLE IF EXISTS " . DB_PREFIX . "gallimage_to_store");
		$this->db->query("DROP TABLE IF EXISTS " . DB_PREFIX . "gallimage_image");
		$this->db->query("DROP TABLE IF EXISTS " . DB_PREFIX . "gallimage_image_description");
	}

	protected function validate() {
		if (!$this->user->hasPermission('modify', 'module/gallimage')) {
			$this->error['warning'] = $this->language->get('error_permission');
		}

		if ((utf8_strlen($this->request->post['name']) < 3) || (utf8_strlen($this->request->post['name']) > 64)) {
			$this->error['name'] = $this->language->get('error_name');
		}

		return !$this->error;
	}
}
